              OPT    l            ;Turn on the file listing
**********************************************************************
*  CRT.S  -  C Runtime code                                          *
*                                                                    *
*  This assembly file contains the C start-up code.  Only the first  *
*  section should be modified.  The remainder of the code is hands-  *
*  off.  This code is compatible with the ias11.exe assembler.       *
*                                                                    *
*      -----> !!! PUT YOUR NAME AND CLASS HERE!!! <-----             *
**********************************************************************

;.-------------------------------------------------------------------.
;|  ORIGINS                                                          |
;|                                                                   |
;| This first section sets up equates for the CODE and DATA sections |
;| of your program.  The following equates are the most common:      |
;|                                                                   |
;|            Program in RAM            Program in EPROM             |
;|           ----------------           ----------------             |
;|           CODE  equ 0x1040           CODE  equ 0xC000             |
;|           GDATA equ 0x5000           GDATA equ 0x1040 (or 0x0000) |
;|           STACK equ 0x7F6A           STACK equ 0x7FFF             |
;|                                                                   |
;|  Note the GDATA is global data in will often not have any data    |
;|  in it.  Also consider using internal RAM for GDATA.              |
;`-------------------------------------------------------------------'

CODE          equ    0x1040       ;Program code section
GDATA         equ    0x5000       ;Global data section
STACK         equ    0x7F6A       ;Same SP as Micro11.


              org    0xfffe       ;Set up any vectors you may need.
              fdb    _startup     ;OK to leave here for RAM or EPROM.


;.-------------------------------------------------------------------.
;|  START-UP CODE                                                    |
;|                                                                   |
;| Leave the code in the remainder of the file as is.                |
;`-------------------------------------------------------------------'
;
; Define Starting Addresses:
;
              sect   0            ;Define the bottom of your ROM (code)
              org    CODE

              sect   1            ;Define the bottom of your RAM (data)
              org    GDATA

;.-------------------------------------------------------------------.
;|  Start of CODE (provided CRT.S routines)                          |
;`-------------------------------------------------------------------'
              sect   0
_startup:     lds    #STACK       ;Initialize the stack pointer
              jsr    _main        ;Run user's main program
              jmp    0xC000       ;In the event of a depressurization...


;
; The rest of the Start-Up routines do not appear in the list file.
;
              OPT     nol         ;Turn off output to the list file.
              OPT     c           ;Show the cycle counts in the code.
;
; Provided Start-Up Routines
;

__lsrd:       cpy    #0
              beq    __lsrd_done
              lsrd
              dey
              bra    __lsrd
__lsrd_done:  rts


__lsld:       cpy    #0
              beq    __lsld_done
              lsld
              dey
              bra    __lsld
__lsld_done:  rts


__asrd:       cmpa   #0
              bpl    __lsrd
__asrd_loop:  cpy    #0
              beq    __asrd_done
              asra
              rorb
              dey
              bra    __asrd_loop
__asrd_done:  rts


__asgnblk:   cpd     #0
             beq     __asgnblk_done
__asgnblk_loop:
             pshb
             ldab    0,y
             stab    0,x
             pulb
             subd    #1
             beq     __asgnblk_done
             inx
             iny
             bra     __asgnblk_loop
__asgnblk_done:
             rts


__muli:
__mulu:       pshx
              pshy
              pshb
              psha
              tsx
              ldaa   3,x
              mul
              pshb
              psha
              ldab   0,x
              ldaa   3,x
              mul
              pula
              aba
              psha
              ldab   1,x
              ldaa   2,x
              mul
              pula
              aba
              pulb
              pulx
              pulx
              pulx
              rts


__divi:       pshx
              psha
              tsta
              bpl    __divi_1
              coma
              comb
              addd   #1
__divi_1:     pshy
              pulx
              tsy
              cpx    #0
              bpl    __divi_2
              xgdx
              coma
              comb
              xgdx
              inx
              com    0,y
__divi_2:     idiv
              xgdx
              tst    0,y
              bpl    __divi_3
              coma
              comb
              addd   #1
__divi_3:     ins
              pulx
              rts


__modi:       pshx
              psha
              tsta
              bpl    __modi_1
              coma
              comb
              addd   #1
__modi_1:     pshy
              pulx
              cpx    #0
              bpl    __modi_2
              xgdx
              coma
              comb
              xgdx
              inx
__modi_2:     idiv
              tsx
              tst    0,x
              bpl    __modi_3
              coma
              comb
              addd   #1
__modi_3:     ins
              pulx
              rts

;
; EQUATES
;
SCSRcrt       equ    0x102E       ;SC Status Register
SCDRcrt       equ    0x102F       ;SC Data Register
;
;.-------------------------------------------------------------------.
;| getch - Waits for and receives one character from the SCI.        |
;`-------------------------------------------------------------------'
; Requires - Nothing
; Returns  - Return value in acc D as an int (char in B, A=00)
; Regs Affected - No other regs affected

_getch:       ldab   SCSRcrt      ;Read the status register and
              andb   #$20         ;  isolate the RDRF bit.
              beq    _getch       ;Wait if RDRF==0
              ldab   SCDRcrt      ;If RDRF==1, get the char.
              clra                ;Zero out the MSB.
              rts


;.-------------------------------------------------------------------.
;| putchar - Sends one character via the SCI.                        |
;`-------------------------------------------------------------------'
; Requires - Char to send on stack (as an int).
; Returns  - int (A=00, B=char)
; Regs Affected - A

_putch:
_putchar:     tsx                 ;X is index to stack.
              ldab   3,X          ;Char (int) above return addr.
_putchar0:    tst    SCSRcrt      ;Check TDRE.
              bpl    _putchar0    ;Wait if TDRE==0.
              stab   SCDRcrt      ;Send the char via the SCI.
              clra
              rts

              OPT    l            ;Turn the list file back on
